#BEGIN COPYRIGHT
#*************************************************************************
#
# Licensed Materials - Property of IBM
# 5725-C94, 5725-C95, 5725-C96
# (C) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
# US Government Users Restricted Rights- Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
#
#*************************************************************************
#END COPYRIGHT

from java.lang import System, String
import sys
import shutil

print "*************************************************************************************"
print "start: init"
print ""

fileSeparator = System.getProperty("file.separator");
configUtilsScript = System.getProperty("was.install.root") + fileSeparator + "util" + fileSeparator + "config" + fileSeparator + "admin" + fileSeparator + "configUtils.py"
print "load configuration utils from ", configUtilsScript
execfile(configUtilsScript);

print ""
print "end: init"


def createDefaultUsersInVMMUserRegistry():
    global adminUserName, adminPassword;
    fileRegistryDocument = "cells/" +  System.getProperty("local.cell") + "/fileRegistry.xml"
    print "The value of fileRegistryDocument is ", fileRegistryDocument
    fileRegistry = System.getProperty("was.repository.root") + fileSeparator +  fileRegistryDocument
    if (adminUserName != "tw_admin"):
        containsAdminUser = adminUserExists(fileRegistry, "tw_admin");
        if(containsAdminUser == "false"):
            AdminTask.addFileRegistryAccount(["-userId", "tw_admin", "-password", adminPassword])
            AdminTask.mapUsersToAdminRole(["-roleName", "deployer", "-userids", ["tw_admin"]])
            AdminTask.mapUsersToAdminRole(["-roleName", "operator", "-userids", ["tw_admin"]])
            print ""
            print "Added tw_admin user"
            print ""

    if (adminUserName != "tw_author"):
        containsAdminUser = adminUserExists(fileRegistry, "tw_author");
        if(containsAdminUser == "false"):
            AdminTask.addFileRegistryAccount(["-userId", "tw_author", "-password", adminPassword])
            AdminTask.mapUsersToAdminRole(["-roleName", "deployer", "-userids", ["tw_author"]])
            AdminTask.mapUsersToAdminRole(["-roleName", "operator", "-userids", ["tw_author"]])
            print ""
            print "Added tw_author user"
            print ""

    if (adminUserName != "tw_user"):
        containsAdminUser = adminUserExists(fileRegistry, "tw_user");
        if(containsAdminUser == "false"):
            AdminTask.addFileRegistryAccount(["-userId", "tw_user", "-password", adminPassword])
            AdminTask.mapUsersToAdminRole(["-roleName", "deployer", "-userids", ["tw_user"]])
            AdminTask.mapUsersToAdminRole(["-roleName", "operator", "-userids", ["tw_user"]])
            print ""
            print "Added tw_user user"
            print ""

    if (adminUserName != "tw_webservice"):
        containsAdminUser = adminUserExists(fileRegistry, "tw_webservice");
        if(containsAdminUser == "false"):
            AdminTask.addFileRegistryAccount(["-userId", "tw_webservice", "-password", adminPassword])
            AdminTask.mapUsersToAdminRole(["-roleName", "deployer", "-userids", ["tw_webservice"]])
            AdminTask.mapUsersToAdminRole(["-roleName", "operator", "-userids", ["tw_webservice"]])
            print ""
            print "Added tw_webservice user"
            print ""

    if (adminUserName != "tw_portal_admin"):
        containsAdminUser = adminUserExists(fileRegistry, "tw_portal_admin");
        if(containsAdminUser == "false"):
            AdminTask.addFileRegistryAccount(["-userId", "tw_portal_admin", "-password", adminPassword])
            AdminTask.mapUsersToAdminRole(["-roleName", "deployer", "-userids", ["tw_portal_admin"]])
            AdminTask.mapUsersToAdminRole(["-roleName", "operator", "-userids", ["tw_portal_admin"]])
            print ""
            print "Added tw_portal_admin user"
            print ""

    if (adminUserName != "tw_runtime_server"):
        containsAdminUser = adminUserExists(fileRegistry, "tw_runtime_server");
        if(containsAdminUser == "false"):
            AdminTask.addFileRegistryAccount(["-userId", "tw_runtime_server", "-password", adminPassword])
            AdminTask.mapUsersToAdminRole(["-roleName", "deployer", "-userids", ["tw_runtime_server"]])
            AdminTask.mapUsersToAdminRole(["-roleName", "operator", "-userids", ["tw_runtime_server"]])
            print ""
            print "Added tw_runtime_server user"
            print ""


    if (adminUserName != "bpmAuthor"):
        containsAdminUser = adminUserExists(fileRegistry, "bpmAuthor");
        if(containsAdminUser == "false"):
            AdminTask.addFileRegistryAccount(["-userId", "bpmAuthor", "-password", adminPassword])
            AdminTask.mapUsersToAdminRole(["-roleName", "deployer", "-userids", ["bpmAuthor"]])
            AdminTask.mapUsersToAdminRole(["-roleName", "operator", "-userids", ["bpmAuthor"]])
            print ""
            print "Added bpmAuthor user"
            print ""

#endDef

def assignAdministrativePrivilegesToUsers():
    global adminUserName;

    #AdminTask.mapUsersToAdminRole(["-roleName", "administrator", "-userids", adminUserName])
    #print ""
    #print "Added administrator administration role to the primary administrator"
    #print ""

    AdminTask.mapUsersToAdminRole(["-roleName", "deployer", "-userids", ["tw_admin", "tw_author", "bpmAuthor"]])
    print ""
    print "Added deployer administration role to tw_admin and tw_author"
    print ""

    AdminTask.mapUsersToAdminRole(["-roleName", "operator", "-userids", ["tw_admin", "tw_author", "bpmAuthor"]])
    print ""
    print "Added operator administration role to tw_admin and tw_author"
    print ""

#endDef

def adminUserExists(fileRegistry, adminUserName):
    try:
        wimAdminUser = '<wim:uid>' + adminUserName + '</wim:uid>'
        f = open(fileRegistry, 'r')
        line = f.readline()
        while line:
            line = f.readline()
            if (line.find(wimAdminUser) >= 0):
                print "found admin user in the file registry"
                f.close()
                return "true";
    except:
        print "File registry document could not be opened or read"
        f.close()
        return "true";
    f.close()
    return "false";

#endDef

def assignAdministrativePrivilegesToGroups():

    AdminTask.mapGroupsToAdminRole(["-roleName", "operator", "-groupids", ["TWSecurityProviderUsers"]] )
    print ""
    print "Added operator administration role to TWSecurityProviderUsers"
    print ""
#endDef

def createRALUserAuthAlias():
    global adminUserName, adminPassword;

    createAuthAlias("RALSecurity_Auth_Alias", adminUserName, adminPassword, "Authentication Alias for RAL User" );

    print ""
    print "Created RAL User Auth Alias "
    print ""

#endDef

#*******************************************************************************************************
# main
#*******************************************************************************************************
print "*************************************************************************************"
print "Start: Configure BPM Administrative File Registry for Lombardi"
print ""
print ""


try:
        cellType = getCellType();
        adminUserName = System.getProperty("bpm.upgrade.username");
        print "The value of adminUserName is " + adminUserName
        adminPassword = System.getProperty("bpm.upgrade.password");
        previousVersion = System.getProperty("bpm.upgrade.previous.version");
        
        twoDigMajor = getTwoDigitMajorVersion(previousVersion);
        if(compareVersions(twoDigMajor, "7.5") == "True") :
            raise Warning;     	
        if (isEmptyString(adminUserName) == "True"):
            adminUserName = "admin";
            print "The value of adminUserName is set to default ", adminUserName

        if (isEmptyString(adminPassword) == "True"):
                adminPassword = "admin";
                print "The value of adminPassword is set to default value"

        if (cellType == "STANDALONE"):
                print "Configuring stand-alone profile."
                print ""
                
                createDefaultUsersInVMMUserRegistry()
                #assignAdministrativePrivilegesToGroups()
                #assignAdministrativePrivilegesToUsers()
                AdminConfig.save();

                print ""
                print "*************************************************************************************"
                print "BPM Administrative File Registry is complete for Upgrade."
                print "*************************************************************************************"
                print ""

        elif (cellType == "DISTRIBUTED"):
                print "Updating the distributed (dmgr or customized) profile"
                # check whether the local node is a deployment manager Node
                isDMgrNode = isDMgrNode();

                if (isDMgrNode != "False"):
                    migratedClusterName = System.getProperty("bpm.upgrade.cluster.name");
                    print ""
                    print "The value of migratedClusterName is ", migratedClusterName;
                    if not (migratedClusterName) or (isEmptyString(migratedClusterName) == "True"):
                        createDefaultUsersInVMMUserRegistry()
                        #assignAdministrativePrivilegesToGroups()
                        #assignAdministrativePrivilegesToUsers()
                        AdminConfig.save();
                    else:
                        print "BPM Administrative File Registry configuration is not needed for migrating cluster"

                print ""
                print "*************************************************************************************"
                print "BPM Administrative File Registry configuration is complete for Upgrade."
                print "*************************************************************************************"
                print ""

        else:
                print "The distributed custom profile does not need BPM Administrative File Registry configuration for Upgrade."

except Warning:
        print "BPM Version is greater than or equal to 7.5";
        print "BPM Administrative File Registry configuration is not needed";
except:
        print ""
        print "*************************************************************************************"
        print "BPM Administrative File Registry configuration for Upgrade could not be completed. The exception type is: ", sys.exc_type, ". The exception description is: ", sys.exc_value
        print "*************************************************************************************"
        print ""
        # rethrow the exception so the calling Ant script fails and eventually results in INSTCONFFAILED instead of INSTCONFSUCCESS
        raise

print ""
print "End: Configure BPM Administrative File Registry for Upgrade"
print "*************************************************************************************"

